#!/usr/bin/X11/tixwish   

proc displayYearCal { day mon year} {
    global fnt bfnt10 bfnt fnt10 monLen
    global covDay covMon covYear covWin
    global weekDaysAbk   covDHwin covDwin

    toplevel .cov 
    
    set covDay $day
    set covMon $mon
    set covYear $year
    set covDHwin ""
    
    set off 3

    frame .cov.y -relief raised -bd 1
    frame .cov.m -relief raised -bd 1
    frame .cov.c -relief raised -bd 1
    pack .cov.y .cov.m .cov.c -side top -fill x -pady 1

    button .cov.y.l -text "<<" -bd 1 -command COVlastYear
    frame .cov.y.y 
    button .cov.y.r -text ">>" -bd 1 -command COVnextYear
    pack .cov.y.l -side left -fill x 
    pack .cov.y.y -side left -fill x -expand 1
    pack .cov.y.r -side right -fill x 
    
    label .cov.y.y.l -text $year -anchor n -font $bfnt
    pack  .cov.y.y.l -side top -fill x

    set monlist "??? Jan Feb Mar Apr Mai Jun Jul Aug Sep Okt Nov Dez"
    frame .cov.m.1 
    frame .cov.m.2
    pack .cov.m.1  .cov.m.2 -side top -fill x
    for { set i 1} { $i<=6} {incr i} {
	button .cov.m.1.$i -text [lindex $monlist $i] -bd 1 -font $bfnt10 -width 1 -command {COVswitchMon}
	pack .cov.m.1.$i -side left -fill x -expand 1
	bind .cov.m.1.$i <Button> {set covWin %W}
    }
    for { set i 7} { $i<=12} {incr i} {
	button .cov.m.2.$i -text [lindex $monlist $i] -bd 1 -font $bfnt10 -width 1 -command {COVswitchMon}
	pack .cov.m.2.$i -side left -fill x -expand 1
	bind .cov.m.2.$i <Button> {set covWin %W}
    }
    if { $mon < 7} {
	 .cov.m.1.$mon configure -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    } else {
	.cov.m.2.$mon configure -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    }

    frame  .cov.c.d
    pack .cov.c.d -side top -fill x
    for {set d 1} {$d<=7} {incr d} {
 	label .cov.c.d.$d -text [lindex $weekDaysAbk [expr $d -1 ]] -relief raised -bd 1  -width 2 -font $bfnt10 -anchor n
 	pack .cov.c.d.$d -side left -fill x -expand 1  -padx 1
    }
    for {set w 0} {$w<=5} {incr w} {
	frame  .cov.c.$w 
	pack .cov.c.$w  -side top -fill x
	for {set d 1} {$d<=7} {incr d} {
	    button .cov.c.$w.$d -text "" -width 1 -font $fnt10 -command jump2CalDate
	    pack .cov.c.$w.$d  -side left
	    bind .cov.c.$w.$d <Button> {set covDwin %W}
	}
    }
    fillMonInCalView

    wm title .cov "Kalender"
}
proc fillMonInCalView {} {
    global monlen
    global fnt fnt10  covDHwin covWDList
    global covMon covDay covYear
    global holidays holidayNames holidayMonth

    if { $covDHwin != "" } {   
	$covDHwin configure  -bg lightgray -activebackground lightgray
    }
    set off [weekDayByDate 1 $covMon $covYear]

    set moff 0
    if { $covMon  == 2 } {
	if {[ expr $covYear % 4] == 0 } { set moff 1} 
    } 
    set ml [expr [lindex $monlen $covMon] + $moff]
    if { $covDay > $ml } { set covDay $ml}

    set mtag [format "%04d-%02d" $covYear $covMon]
    if { [lsearch $holidayMonth $mtag] >=0 } {
	set hlist $holidays($mtag)
    } else {
	set hlist ""
    }

    for {set w 0} {$w<=5} {incr w} {
	for {set d 1} {$d<=7} {incr d} {
	    set wd [expr $w*7+$d -$off]
	    if { $wd <=0  || $wd > $ml} {
		.cov.c.$w.$d configure -text ""  -width 1 -font $fnt10 -relief flat -state disabled 
	    } else {
		.cov.c.$w.$d configure  -text $wd -width 1 -font $fnt10 -relief raised -state normal
	    }
	    if { $covDay == $wd} {
		.cov.c.$w.$d configure -bg wheat -activebackground wheat
		set covDHwin .cov.c.$w.$d
	    }
	    if { $d >5} {
		.cov.c.$w.$d configure -fg red4 -activeforeground red4 
	    } elseif { [lsearch $hlist $wd] >=0} {
		.cov.c.$w.$d configure -fg red4 -activeforeground red4 
	    } else {	    
		.cov.c.$w.$d configure -fg black -activeforeground  black
	    }
	    set covWDList($w-$d) $wd
	}
    }
    update 
}

proc jump2CalDate { } {
    global covWDList covDwin covDay covYear covMon covDHwin
    global sDay sMon sYear 

    set list [split $covDwin .]
    set w [lindex  $list 3]
    set d [lindex  $list 4]
    set covDay $covWDList($w-$d)

    $covDHwin configure  -bg lightgray -activebackground lightgray
    .cov.c.$w.$d configure -bg wheat -activebackground wheat
    set covDHwin .cov.c.$w.$d

    set sDay  $covDay
    set sMon  $covMon
    set sYear $covYear

    puts "$sDay $sMon $sYear"
    jump2Date
}
proc  COVswitchMon {} {
    global covWin covMon covDay covYear
    global sDay sMon sYear 

    if {$covMon <=6} {
	.cov.m.1.$covMon configure  -fg black -bg lightgray -activebackground lightgray -activeforeground black
    } else {
	.cov.m.2.$covMon configure  -fg black -bg lightgray -activebackground lightgray -activeforeground black
    }
    set covMon [lindex [split $covWin .] 4]

    puts " DATE $covDay $covMon $covYear"
    fillMonInCalView
    puts ">DATE $covDay $covMon $covYear"

    if {$covMon <=6} {
	puts [.cov.m.1.$covMon cget -bg]
	update
	.cov.m.1.$covMon configure  -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    } else {
	.cov.m.2.$covMon configure  -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    }
    set sDay  $covDay
    set sMon  $covMon
    set sYear $covYear
    jump2Date
}

proc COVlastYear { } {
    global covMon covDay covYear
    global sDay sMon sYear 
    
    incr covYear -1
    
    .cov.y.y.l configure -text $covYear

    fillMonInCalView

    set sDay  $covDay
    set sMon  $covMon
    set sYear $covYear
    jump2Date
}
proc COVnextYear { } {
    global covMon covDay covYear
    global sDay sMon sYear 

    incr covYear 1
    
    .cov.y.y.l configure -text $covYear
    fillMonInCalView
    set sDay  $covDay
    set sMon  $covMon
    set sYear $covYear
    jump2Date
}

