#!/usr/bin/X11/tixwish


proc createNewItem { } {
    global toolSelection username today

    if { $toolSelection == "K" } {
	newDate $username $today 1200
    } elseif { $toolSelection == "T" } {
	newTODO
    } elseif { $toolSelection == "A" } {
	newAddress
    }
}

#proc drawNewView { which } {
proc drawNewView {  } {
    global toolSelection
    
    switch $toolSelection {
	K {drawCalendar}
	A {}
	T { 
	    getProjTodoLists
	    refillTODO 
	}
    }
}


proc printCurCanvas { } {
    global toolSelection
    
    switch $toolSelection {
	K {printCal .pr.c.c}
	A {}
	T {printProjs}
    }
    closeWin .pr
}

proc printDialog { } {
    global printerList stdPrinter selPrinter printMode
    global bfnt fnt toolSelection calTyp
    global prStartD prStartM prStartY prStopD prStopM prStopY
    global curDay curMon curYear monlen

    set printMode c

    toplevel .pr

    frame .pr.t -relief raised -bd 1
    frame .pr.c 
    frame .pr.b 
    pack .pr.t .pr.c .pr.b -side top -fill x
    

    frame .pr.t.0
    frame .pr.t.1 -relief ridge -bd 2
    pack  .pr.t.0  -side top  -fill x
    if {$toolSelection == "K"} {
	pack  .pr.t.1  -side top  -fill x
    }

    tixOptionMenu .pr.t.0.pr -label "Drucker :  "  -variable selPrinter
    .pr.t.0.pr subwidget label configure -font $bfnt
    .pr.t.0.pr subwidget menubutton configure -font $fnt
    .pr.t.0.pr subwidget menu configure -font $bfnt
    foreach printer $printerList {
	.pr.t.0.pr add command $printer -label $printer
    }
    set selPrinter [lindex $printerList $stdPrinter ]
    pack .pr.t.0.pr -side left

    if {$toolSelection == "K"} {
	frame .pr.t.1.1
	frame .pr.t.1.2
	frame .pr.t.1.3
	frame .pr.t.1.4
	pack .pr.t.1.1 .pr.t.1.2 .pr.t.1.3 .pr.t.1.4 -side top -fill x
	
	radiobutton .pr.t.1.1.c -variable printMode -value c -text "bersicht ausdrucken" -command togglePRdates
	radiobutton .pr.t.1.2.l -variable printMode -value l -text "Liste ausdrucken" -command togglePRdates
	pack .pr.t.1.1.c .pr.t.1.2.l  -side left
	

	switch $calTyp {
	    d { set prStartD $curDay
		set prStartM $curMon
		set prStartY $curYear
		set prStopD $curDay
		set prStopM $curMon
		set prStopY $curYear
	    }	
	    w {
		set shift  [ weekDayByDate $curDay $curMon $curYear]
		set ret [calcDate $curDay $curMon $curYear [expr -1* $shift]]
		set prStartD  [lindex $ret 0]
		set prStartM  [lindex $ret 1]
		set prStartY  [lindex $ret 2]
		set ret [calcDate  $prStartD $prStartM $prStartY  7]
		set prStopD  [lindex $ret 0]
		set prStopM  [lindex $ret 1]
		set prStopY  [lindex $ret 2]
	    }
	    m {
		set prStartD  1
		set prStartM $curMon
		set prStartY $curYear
		set shift  [ weekDayByDate 1 $curMon $curYear]
		set ret [calcDate  $prStartD $prStartM $prStartY  [expr -1* $shift]]
		set prStartD  [lindex $ret 0]
		set prStartM  [lindex $ret 1]
		set prStartY  [lindex $ret 2]

		set prStopD [ lindex $monlen $curMon]
		if {$curMon == 2} {
		    if { [expr $curYear %4 ] == 0} {
			incr prStopD
		    }
		}
		set prStopM $curMon
		set prStopY $curYear
		set shift  [ weekDayByDate $prStopD $curMon $curYear]
		set ret [calcDate  $prStopD $prStopM $prStopY  [expr 6-$shift]]
		set prStopD  [lindex $ret 0]
		set prStopM  [lindex $ret 1]
		set prStopY  [lindex $ret 2]
	    }
	}

	label .pr.t.1.3.s -text "    " -font $fnt
	tixControl .pr.t.1.3.d  -label "Beginn" -min 0 -max 31 -integer 1  \
	    -options {  entry.width 2 label.width 8 } -variable prStartD -selectmode immediate -autorepeat true
	tixControl .pr.t.1.3.m -options { entry.width 2} -label "." -min 0 -max 12 -integer 1 -variable prStartM -selectmode immediate -autorepeat true
	tixControl .pr.t.1.3.y -options { entry.width 4} -label "." -min 1999 -max 2100 -integer 1  -variable prStartY -selectmode immediate -autorepeat true
	.pr.t.1.3.d subwidget label configure -font $bfnt
	.pr.t.1.3.d subwidget entry configure -font $fnt
	.pr.t.1.3.m subwidget label configure -font $bfnt
	.pr.t.1.3.m subwidget entry configure -font $fnt
	.pr.t.1.3.y subwidget label configure -font $bfnt
	.pr.t.1.3.y subwidget entry configure -font $fnt
	.pr.t.1.3.d  configure -state disabled
	.pr.t.1.3.m  configure -state disabled
	.pr.t.1.3.y  configure -state disabled
	pack .pr.t.1.3.s .pr.t.1.3.d .pr.t.1.3.m .pr.t.1.3.y -side left
	
	label .pr.t.1.4.s -text "    " -font $fnt
	tixControl .pr.t.1.4.d  -label "Ende" -min 0 -max 31 -integer 1  \
	    -options {  entry.width 2 label.width 8 } -variable prStopD -selectmode immediate -autorepeat true
	tixControl .pr.t.1.4.m -options { entry.width 2} -label "." -min 0 -max 12 -integer 1 -variable prStopM -selectmode immediate -autorepeat true
	tixControl .pr.t.1.4.y -options { entry.width 4} -label "." -min 1999 -max 2100 -integer 1  -variable prStopY -selectmode immediate -autorepeat true
	.pr.t.1.4.d subwidget label configure -font $bfnt
	.pr.t.1.4.d subwidget entry configure -font $fnt
	.pr.t.1.4.m subwidget label configure -font $bfnt
	.pr.t.1.4.m subwidget entry configure -font $fnt
	.pr.t.1.4.y subwidget label configure -font $bfnt
	.pr.t.1.4.y subwidget entry configure -font $fnt
	.pr.t.1.4.d  configure -state disabled
	.pr.t.1.4.m  configure -state disabled
	.pr.t.1.4.y  configure -state disabled
	pack .pr.t.1.4.s .pr.t.1.4.d .pr.t.1.4.m .pr.t.1.4.y -side left

	canvas  .pr.c.c -width 540 -height 780 -background white

	#    pack .pr.c.c
    }
    

    button .pr.b.abb -text "Abbruch" -command {closeWin .pr}
    pack .pr.b.abb -side left

    button .pr.b.pr -text "Drucken" -command printCurCanvas
    pack .pr.b.pr -side right
    
    if {$toolSelection == "K"} {
	centerWin .pr 240 164
    } else {
	centerWin .pr 200 76
    }
    wm title .pr "Drucken"
    update 
    grab .pr
    
     global toolSelection   
}

proc togglePRdates { } {
    global printMode

    if { $printMode == "c" } {
	.pr.t.1.3.d configure -state disabled
	.pr.t.1.3.m configure -state disabled
	.pr.t.1.3.y configure -state disabled
	.pr.t.1.4.d configure -state disabled
	.pr.t.1.4.m configure -state disabled
	.pr.t.1.4.y configure -state disabled
    } else {
	.pr.t.1.3.d configure -state normal
	.pr.t.1.3.m configure -state normal
	.pr.t.1.3.y configure -state normal
	.pr.t.1.4.d configure -state normal
	.pr.t.1.4.m configure -state normal
	.pr.t.1.4.y configure -state normal
    }
}

proc ErrorDialog { msg } {
    toplevel .err
    
    label .err.lab -text "Error"  -font -*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-* -fg red
    message .err.msg -text $msg -font -*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-* -width 256
    button .err.but -text " O.K. " -command {closeWin .err}
    pack .err.lab .err.msg  -side top
    pack  .err.but -side bottom
    wm title .err "Error"
    centerWin .err 270 120
    grab .err
}
proc FatalErrorDialog { msg } {
    toplevel .ferr
    
    label .ferr.lab -text "Fatal Error"  -font -*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-* -fg red
    message .ferr.msg -text $msg -font -*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-* -width 300
    button .ferr.but -text " O.K. " -command {exitClient}
    pack .ferr.lab .ferr.msg  -side top
    pack  .ferr.but -side bottom
    wm title .ferr "Fatal Error"
    centerWin .ferr 320 120
    grab .ferr
}
proc ServerDownDialog { } {
    global progname sdDialogRunning
    
    if { $sdDialogRunning == 0} {
	set sdDialogRunning 1
	toplevel .sdd
	label .sdd.lab -text "Fatal Error"  -font -*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-* -fg red
	message .sdd.msg -text "Der $progname-Server kann nicht erreicht werden.\nBitte melden sie dies ihrem Administrator und starten sie $progname spter neu." -font -*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-* -width 300
	button .sdd.but -text " O.K. " -command {exitClient}
	pack .sdd.lab .sdd.msg  -side top
	pack  .sdd.but -side bottom
	wm title .sdd "Error"
	centerWin .sdd 320 160
	grab .sdd
    }
}

proc loginDialog { prefUser } {
    global username password env cputype progname
    global bfnt fnt minkoIcon128 docPath

    toplevel .log

    
    wm title .log "Login to $progname"
    frame .log.t -relief raised -bd 1
    frame .log.b -relief flat
    pack .log.t .log.b -side top -fill x -padx 2

    frame .log.t.l 
    frame .log.t.r
    pack .log.t.l -side left -fill both
    pack .log.t.r -side left -fill both -padx 8 -pady 12

    
    button .log.t.l.b -image  [image create pixmap -data $minkoIcon128]
    pack .log.t.l.b

#    label .log.t.r.0 -text "" -font $bfnt
    label .log.t.r.1 -text "Benutzername" -width 16 -font $bfnt
    entry .log.t.r.2 -textvariable username -width 16 -font $fnt
    label .log.t.r.3 -text "" -font $bfnt

    label .log.t.r.4 -text "Passwort" -width 16 -font $bfnt
    entry .log.t.r.5 -textvariable password -width 16 -font $fnt -show *
    for {set i 1} {$i<= 5} {incr i} { pack .log.t.r.$i -side top}

    button .log.b.c -text " Abbruch " -command exitClient -font $bfnt
    button .log.b.h -text " Hilfe "  -font $bfnt -command { 
	set docPath "$TclBinPath/../html"
	displayLoginHelp 
    }
    button .log.b.o -text " Login "  -command doLogin -font $bfnt
    pack .log.b.c .log.b.h -side left
    pack .log.b.o -side right

    if { $prefUser == "-" } {
	
	set file [ format "%s/.kapa" $env(HOME)]
	if { [file exists $file] ==1 } {
	    set fid [ open $file "r" ]
	    set username [gets $fid ]
	    close $fid
	} else { 
	    catch {set username $env(USER) }
	}
    } else {
	set username $prefUser
    }
    centerWin .log 296 170
    
    update
    bind .log <Return>  {doLogin}
    bind . <Return>  {doLogin}
    bind .log <KP_Enter>  {doLogin}
    bind . <KP_Enter>  {doLogin}
    grab .log
    
}

proc doLogin { } {
    global username password env cur_Cal fullUsername eddLock kalWin selCalObj refreshEna progname 
    global prvCal bfnt12 adr_list ToolBarButtons
    global up_displayIgnore up_displayInfo up_displayToolTips showIgnore ignoreInfo ballon
    global ignoreIcon_in ignoreIcon_out ignoreInfoIcon_in ignoreInfoIcon_out
    
    closeWin .log
    openMeter "starting $progname" "contacting Server"
    if { $password == "" } { set password "" }
    set ret [login $username $password]

    if { [lindex $ret 0] == "OK" } {

	updateMeter 9 "read User Preferences"
	
	check4NewLists
	readUserPrefs	
	set showIgnore $up_displayIgnore
	set ignoreInfo [ expr 1- $up_displayInfo]
	if { $ignoreInfo == 1} {
	    .t.t.c.k.ii configure -image [image create pixmap -data $ignoreInfoIcon_out]
	} else {
	    .t.t.c.k.ii configure -image [image create pixmap -data $ignoreInfoIcon_in]
	}
	if { $showIgnore == 0 } {
	    .t.t.c.k.ig configure -image [image create pixmap -data $ignoreIcon_out]
	} else {
	    .t.t.c.k.ig configure -image [image create pixmap -data $ignoreIcon_in]
	}
#	if { $up_displayToolTips == 0 } {$ballon -initwait 86400000 }
	if { $up_displayToolTips == 0 } {$ballon configure -state none }
	    
	
 	set file [ format "%s/.termine" $env(HOME)]
 	set fid [ open $file "w" ]
 	puts $fid $username
 	close $fid
	set cur_Cal $username
	set prvCal $username
	setCurCalMenuTitel

	updateMeter 23 "getting user lists"
	set fullUsername  [getFullUserName $username u] 
	drawCalendarList 
	updateMeter 31 "creating calendar"
	drawUsersCalendar 
	updateMeter 49 "creating addressbook"
#	fillAdrList 
	set adr_list [request getAdrList $username ]
	fillAddress
	updateMeter 64 "getting project lists"
	getProjTodoLists 
	updateMeter 99 "creating project view"
	fillTODO 
	updateMeter 100 "done"
	foreach but $ToolBarButtons {
	    $but configure -state normal
	}
	update
	set eddLock 0
	    set refreshEna 1 
	closeMeter
	bind . <Alt-q> {exitClient}
    } elseif {[lindex $ret 0] == "FATAL" } {
	FatalErrorDialog [string range $ret 13 end]
    } else {
	ErrorDialog $ret
	closeMeter
	tkwait window .err
	loginDialog -
    }
}
    
proc centerWin { win w h } {
    set masterGeo [ split [ wm geometry .] x+ ]
    set mdx [lindex $masterGeo 0 ]
    set mdy [lindex $masterGeo 1 ]
    set mx [lindex $masterGeo 2 ]
    set my [lindex $masterGeo 3 ]
    
    set x [expr $mx + $mdx/2 -$w/2 ]
    set y [expr $my + $mdy/2 -$h/2 ]
    
    set geo [format "%dx%d+%d+%d" $w $h  $x $y ]
    wm geometry $win $geo
    wm transient $win .
}
proc readUserPrefs { } {
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm username
    global up_beep up_signalCommand up_calPerm
    global uCalKernStart uCalKernEnd uGlobalSlotsD uGlobalSlotsW uGlobalSlotsM uGlobalSlotsWG can
    global up_displayIgnore up_displayInfo up_displayToolTips

    set ret [ request getUserPrefs $username]
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    if { [string range $ret  0 2] == "ERR" } {
	ErrorDialog $ret
    } else {
	set grp [lindex $ret 0]
	set up_defEinlPerm  [lindex $grp 0]
	set up_defTeilnPerm [lindex $grp 1]
	set up_defInfoPerm  [lindex $grp 2]
	set up_defExtPerm   [lindex $grp 3]
	set up_beep           [lindex $ret 1]
	set up_signalCommand  [lindex $ret 2]
	set grp [lindex $ret 3]
	foreach ent $grp { 
	    set group [lindex $ent 0]
	    set up_calPerm($group) [lindex $ent 1]
	}
	if { [lindex $ret 4] != "" } {
#	    puts " getting calFormat"
	    set calFormat  [lindex $ret 4]
	    set uCalKernStart  [lindex $calFormat 0]
	    set uCalKernEnd    [lindex $calFormat 1]
	    set uGlobalSlotsD  [lindex $calFormat 2]
	    set uGlobalSlotsW  [lindex $calFormat 3]
	    set uGlobalSlotsM  [lindex $calFormat 4]
	    set uGlobalSlotsWG [lindex $calFormat 5]
	    $can delete all
	    drawWeekGrid
	}
	set up_displayIgnore   [lindex $ret 5]
	set up_displayInfo     [lindex $ret 6]
	set up_displayToolTips [lindex $ret 7]
# 	drawNewView
    }
}
proc writeUserPrefs { } {
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm username
    global up_beep up_signalCommand up_calPerm up_pwd
    global uCalKernStart uCalKernEnd uGlobalSlotsD uGlobalSlotsW uGlobalSlotsM uGlobalSlotsWG
    global up_displayIgnore up_displayInfo up_displayToolTips

    set ret [transfer saveUserPrefs $username $up_defEinlPerm $up_defTeilnPerm $up_defInfoPerm $up_defExtPerm $up_beep $up_signalCommand [array get up_calPerm] $up_pwd "$uCalKernStart $uCalKernEnd $uGlobalSlotsD $uGlobalSlotsW $uGlobalSlotsM $uGlobalSlotsWG" $up_displayIgnore $up_displayInfo $up_displayToolTips]
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    if { [string range $ret 0 2] == "ERR" } {
	ErrorDialog $ret
    } 

}


proc openMeter { titel msg} {
    global bfnt bfnt12  animImg fnt12
    global metStat

    update
    toplevel .met
    frame .met.t
    frame .met.m
    pack .met.t -side top -fill x
    pack .met.m -side top -fill x -padx 4

    button .met.t.b -image  [image create pixmap -data $animImg(0)]
    pack .met.t.b -side top
    set metStat 0

    label .met.m.l -text $msg -font $fnt12 -justify center -anchor n
    pack .met.m.l -side top
    wm title .met $titel
    centerWin .met 130 154
}
proc updateMeter {val msg} {
    global metStat animImg
    .met.m.l  configure -text $msg
    set stat [expr int(floor($val*12.5/100+.05))]
    for {set i $metStat} { $i <$stat } {incr i} {
	.met.t.b configure -image  [image create pixmap -data $animImg($i)]
	update
	after 100
    }
    set metStat $stat
    update
}
 proc closeMeter {} {
     global  animImg
     .met.t.b configure -image  [image create pixmap -data $animImg(12)]
     update
     after 500
     closeWin .met
 }

# proc openMeter { titel msg} {
#     global bfnt bfnt12

#     toplevel .met
#     frame .met.f -relief flat -bd 1 
#     pack .met.f -side top -fill both
    
#     label .met.f.0 -text "" -font $bfnt12
#     tixMeter .met.f.m -value 0 -text " "  -fillcolor "#FFAE1A" -width 240
#     label .met.f.1 -text "" -font $bfnt12
#     label .met.f.l -text $msg -font $bfnt -justify center -anchor n
#     label .met.f.2 -text "" -font $bfnt12
#     pack .met.f.0 .met.f.m .met.f.1 .met.f.l .met.f.2 -side top -fill x
#     wm title .met $titel
#     centerWin .met 256 96
#     update 

#     grab .met

# }
# proc updateMeter {val msg} {
#     .met.f.m configure -value [expr $val/100.]
#     .met.f.l configure -text $msg
#     update
# }
#  proc closeMeter {} {
#      closeWin .met
#  }

proc doLock { } {
    global fnt isLock
    
    if { $isLock == 0} {
	toplevel .lock
	centerWin .lock 88 2
	wm title .lock "Bitte warten"
	tixMwm decoration .lock -title 0
	update
	after 50
	update idletasks
	catch {grab .lock}
	incr isLock 
    }
}
proc raiseLock { win } {
    global isLock
    if {$isLock == 1 } { wm transient .lock $win}
}
proc unLock { } {
    global isLock
    
    incr isLock -1
    if {$isLock == 0 } {
	update
	after 50
	update idletasks
	destroy .lock
    }
}

proc closeWin { win} {
    doLock
    destroy $win
    update
    redrawMainCanvas
    unLock
}
proc exitClient { } {
    closeApp
    after 500
    exit
}

proc aboutMinkowsky { } {
    global fnt bfnt progname hbfnt lfnt  lbfnt minkoIcon128 bfnt12 fnt10

    toplevel .ab
    wm title .ab "about $progname"
    frame .ab.t -relief raised -bd 1
    frame .ab.b -relief flat
    pack .ab.t  -side top -fill x
    pack .ab.b -side top -fill x -pady 2

    frame .ab.t.l 
    frame .ab.t.r
    pack .ab.t.l  -side left -fill both
    pack  .ab.t.r -side left -fill both -padx 4 -pady 4
    
    button .ab.t.l.b -image  [image create pixmap -data $minkoIcon128]
    pack .ab.t.l.b
    
    label .ab.t.r.1 -text [string toupper $progname ] -justify center -font $hbfnt  -anchor n
    label .ab.t.r.2 -text "Raum/Zeit-Verwaltung" -justify center -font $lbfnt  -anchor n
    label .ab.t.r.3 -text "" -justify left -font $bfnt12 -anchor nw
    label .ab.t.r.4 -text "von R. Goetz" -justify left -font $bfnt12 -anchor nw
    frame .ab.t.r.7 
    label .ab.t.r.7.l -text "Version 0.4.0" -justify left -font $bfnt12 -anchor nw
    label .ab.t.r.7.r -text "   vom  20.5.2001" -justify left -font $bfnt12 -anchor nw
    for {set i 1} {$i<=4} {incr i } {
	pack .ab.t.r.$i -side top -fill x
    }
    pack .ab.t.r.7 -side bottom -fill x
    pack .ab.t.r.7.l -side left
    pack .ab.t.r.7.r -side right
    button .ab.b.ok -text " Schliessen  " -command { closeWin .ab}
    pack .ab.b.ok -side right
    
#    update 
    grab .ab
    centerWin .ab 348 172
}

proc getPrinterList { } {
    global printerList stdPrinter
    set fid [open "/etc/printcap" ]
    
    set capList ""
    set c [gets $fid line]
    set store 1
    while {! [eof $fid] } {
	if { $c > 0} {
	    if { [string range  $line 0 0] != "\#" } {
		if { $store == 1} {
		    lappend capList $line
		    set store 0 
		}
		if { [string range $line end end] != "\\" } {
		    set store 1
		}
	    }
	}
	set c [gets $fid line]
    }
    
    set printerList ""
    set i 0
    set stdPrinter 0
    foreach line $capList {
	set pr [ lindex [split $line | ] 0]
	if {$pr == "lp" } {
	    set pr [ lindex [split $line | ] 1]
	    set stdPrinter $i
	}
	lappend printerList $pr
	incr i
    }
    
}


set TclBinPath [getBinPath]
source $TclBinPath/utils.tcl
source $TclBinPath/add.tcl
source $TclBinPath/viewDate.tcl
source $TclBinPath/wochenView.tcl
source $TclBinPath/prefs.tcl
source $TclBinPath/addresss.tcl
source $TclBinPath/todo.tcl
source $TclBinPath/images.tcl
source $TclBinPath/help.tcl
source $TclBinPath/html.tcl
source $TclBinPath/anim.tcl
source $TclBinPath/cal.tcl




set toolSelection K
set calTyp "w"


set weekDays "Montag Dienstag Mittwoch Donnerstag Freitag Sonnabend Sonntag Montag Dienstag Mittwoch Donnerstag Freitag Sonnabend Sonntag"
set weekDaysAbk "Mo Di Mi Do Fr Sa So"
set monlen "0 31 28 31 30 31 30 31 31 30 31 30 31"
set monAbk "??? Jan. Feb. Mrz Apr. Mai Juni Juli Aug. Sep. Okt. Nov. Dez."
set day 1
set mon 0
set year 2001

set day [string trimleft [exec date +%d] 0 ]
set mon [string trimleft [exec date +%m] 0 ]
set year [exec date +%Y]
set tday $day
set tmon $mon
set tyear $year
set curOffset [exec date +%w]
set curOffset [expr ($curOffset+6) % 7]
set uCalKernStart 7
set uCalKernEnd 20
set uGlobalSlotsD 3
set uGlobalSlotsW 3
set uGlobalSlotsWG 2
set uGlobalSlotsM 3
set up_displayIgnore   0
set up_displayInfo     1
set up_displayToolTips 1



set dlist [calcDate $day $mon $year [expr -1 *$curOffset ] ]
set day  [lindex $dlist 0]
set mon  [lindex $dlist 1]
set year [lindex $dlist 2]
set curDay    $day
set curMon    $mon
set curYear   $year
set thisWeekStartD $day
set thisWeekStartM $mon
set thisWeekStartY $year
#set curOffset 0

#incr day [expr -1 *$wdOffset ]
#set wdOffset 0
set progname "Minkowsky"
set lastListUpdate 0
set showIgnore 0
set ignoreInfo 0
set showUsersInGroupCal 0
set curTimeMark ""
set calTyp w
set groupOnlyCommon 0
set groupByUsers 0
set sdDialogRunning 0
set refreshEna 0
set isLock 0
set lastRefresh 0
set holidayMonth ""
#set calSplitHour 25
initPartStatus
initTODO


set pbfnt8 -*-lucidatypewriter-medium-r-*-*-8-*-*-*-*-*-*-*
set bpfnt8 -*-lucidatypewriter-medium-r-*-*-8-*-*-*-*-*-*-*
set pfnt8 -*-lucidatypewriter-medium-r-normal-sans-8-*-*-*-*-*-*-*
set fnt8  -*-helvetica-medium-r-*-*-8-*-*-*-*-*-*-*
set bfnt8 -*-helvetica-bold-r-*-*-8-*-*-*-*-*-*-*


set pbfnt10 -*-lucidatypewriter-medium-r-*-*-10-*-*-*-*-*-*-*
set bpfnt10 -*-lucidatypewriter-medium-r-*-*-10-*-*-*-*-*-*-*
set pfnt10 -*-lucidatypewriter-medium-r-normal-sans-10-*-*-*-*-*-*-*
set fnt10  -*-helvetica-medium-r-*-*-10-*-*-*-*-*-*-*
set bfnt10 -*-helvetica-bold-r-*-*-10-*-*-*-*-*-*-*

set pbfnt11 -*-lucidatypewriter-medium-r-*-*-11-*-*-*-*-*-*-*
set bpfnt11 -*-lucidatypewriter-medium-r-*-*-11-*-*-*-*-*-*-*
set pfnt11 -*-lucidatypewriter-medium-r-normal-sans-11-*-*-*-*-*-*-*
set fnt11  -*-helvetica-medium-r-*-*-11-*-*-*-*-*-*-*
set bfnt11 -*-helvetica-bold-r-*-*-11-*-*-*-*-*-*-*

set pbfnt12 -*-lucidatypewriter-medium-r-*-*-12-*-*-*-*-*-*-*
set bpfnt12 -*-lucidatypewriter-medium-r-*-*-12-*-*-*-*-*-*-*
set pfnt12 -*-lucidatypewriter-medium-r-normal-sans-12-*-*-*-*-*-*-*
set fnt12  -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
set bfnt12 -*-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*


set pbfnt -*-lucidatypewriter-medium-r-*-*-14-*-*-*-*-*-*-*
set bpfnt -*-lucidatypewriter-medium-r-*-*-14-*-*-*-*-*-*-*
set pfnt -*-lucidatypewriter-medium-r-normal-sans-14-*-*-*-*-*-*-*
set fnt  -*-helvetica-medium-r-*-*-14-*-*-*-*-*-*-*
set bfnt -*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*

set sbfnt -*-helvetica-bold-r-*-*-11-*-*-*-*-*-*-*
set wpfnt -*-fixed-medium-r-*-*-10-*-*-*-*-*-*-*

set lfnt -*-helvetica-medium-r-*-*-18-*-*-*-*-*-*-*
set lbfnt -*-helvetica-bold-r-*-*-18-*-*-*-*-*-*-*
set hbfnt -*-helvetica-bold-r-*-*-24-*-*-*-*-*-*-*

 
set eddLock 1
initIcons
set lastProjTodoChange 0



frame .t -relief raised -bd 1 -width 840
frame .n
pack .t .n -side top -fill x -expand 1


#Ballonhelp 

set ballon .t.bal
tixBalloon $ballon  -initwait 2000 -state balloon
#$ballon subwidget message configure
#$ballon subwidget label configure -background grey90


#Toolbar
set ToolBarButtons ""
frame .t.t 
pack .t.t  -side top -fill x -expand 1 
button .t.t.q  -image [image create pixmap -data $quitIcon] -command exitClient -state disabled
lappend ToolBarButtons .t.t.q
pack .t.t.q  -side left  -fill y
$ballon bind .t.t.q -balloonmsg "Beende $progname"

label .t.t.s0 -text " " -width 2
pack .t.t.s0 -side left

button .t.t.rl -image [image create pixmap -data $reloadIcon ] -command { drawNewView } -state disabled
pack .t.t.rl -side left -fill y -padx 1
lappend ToolBarButtons .t.t.rl
$ballon bind .t.t.rl -balloonmsg "Kalender neuladen"

button .t.t.pr -image [image create pixmap -data $printerIcon ]  -command printDialog -state disabled
pack .t.t.pr -side left -fill y -padx 1
lappend ToolBarButtons .t.t.pr
$ballon bind .t.t.pr -balloonmsg "Drucken"

label .t.t.s0a -text " " -width 2
pack .t.t.s0a -side left

button .t.t.n  -image [image create pixmap -data $newIcon] -command {createNewItem } -state disabled
lappend ToolBarButtons .t.t.n
pack .t.t.n  -side left  -fill y -padx 1
$ballon bind .t.t.n -balloonmsg "Lege einen neuen Termin an."
#$ballon bind .t.t.np -balloonmsg "Lege einen neues Peoject an."

frame .t.t.c -relief   flat -bd 0
pack .t.t.c -side left -fill x


frame .t.t.c.k -relief flat -bd 0
frame .t.t.c.a -relief flat -bd 0
frame .t.t.c.t -relief flat -bd 0
pack .t.t.c.k .t.t.c.a .t.t.c.t -side left -fill x

label .t.t.c.k.s1 -text " " -width 2
pack .t.t.c.k.s1 -side left

#Buttons im Kalender Toolbar
button .t.t.c.k.tv -image [image create pixmap -data $dayCalIcon] -command {switch2CalTyp d} -state disabled
button .t.t.c.k.wv -image [image create pixmap -data $weekCalIcon] -command {switch2CalTyp w} -state disabled
button .t.t.c.k.mv -image [image create pixmap -data $monthCalIcon] -command {switch2CalTyp m} -state disabled
lappend ToolBarButtons .t.t.c.k.tv .t.t.c.k.wv .t.t.c.k.mv
pack .t.t.c.k.tv .t.t.c.k.wv .t.t.c.k.mv  -side left 
$ballon bind .t.t.c.k.tv -balloonmsg "Auf die Tagesbersicht wechseln"
$ballon bind .t.t.c.k.wv -balloonmsg "Auf die Wochenbersicht wechseln"
$ballon bind .t.t.c.k.mv -balloonmsg "Auf die Monatsbersicht wechseln"

label .t.t.c.k.s2 -text " " -width 2
pack .t.t.c.k.s2 -side left


button .t.t.c.k.gh -image [image create pixmap -data $goHomeIcon] -command {jump2Today} -state disabled
button .t.t.c.k.jt -image [image create pixmap -data $jumpIcon] -command {jump2DateDialog} -state disabled
lappend ToolBarButtons .t.t.c.k.gh .t.t.c.k.jt
pack .t.t.c.k.gh .t.t.c.k.jt -side left -padx 1
$ballon bind .t.t.c.k.gh  -balloonmsg "Zurck zum aktuelle\n Datum springen"
$ballon bind .t.t.c.k.jt  -balloonmsg "ffne bersichtskalender und springe\nzu einem beliebigen Datum"



label .t.t.c.k.s2b -text " " -width 2
pack .t.t.c.k.s2b -side left

button .t.t.c.k.ii -image [image create pixmap -data $ignoreInfoIcon_in]  -state disabled -command {
    set ignoreInfo [ expr $ignoreInfo ^ 1]
    if { $ignoreInfo == 1} {
	.t.t.c.k.ii configure -image [image create pixmap -data $ignoreInfoIcon_out]
    } else {
	.t.t.c.k.ii configure -image [image create pixmap -data $ignoreInfoIcon_in]
    }
    drawCal
}
button .t.t.c.k.ig -image [image create pixmap -data $ignoreIcon_out] -state disabled -command {
    set showIgnore [ expr $showIgnore ^ 1]
    if { $showIgnore == 0 } {
	.t.t.c.k.ig configure -image [image create pixmap -data $ignoreIcon_out]
    } else {
	.t.t.c.k.ig configure -image [image create pixmap -data $ignoreIcon_in]
    }
    drawCal
}
button .t.t.c.k.oc -image [image create pixmap -data $onlyCommonIcon_out] -state disabled -command {
    set groupOnlyCommon [ expr $groupOnlyCommon ^ 1]
    if { $groupOnlyCommon == 0 } {
	.t.t.c.k.oc configure -image [image create pixmap -data $onlyCommonIcon_out]
    } else {
	.t.t.c.k.oc configure -image [image create pixmap -data $onlyCommonIcon_in]
    }
    if { [ lsearch $groupList [string trim $cur_Cal ]] >=0 } { drawCal }
} 
button .t.t.c.k.mc -image [image create pixmap -data $multiUserGroupCalIcon_out] -state disabled  -command {
    set groupByUsers [ expr $groupByUsers ^ 1]
    if { $groupByUsers == 0 } {
	.t.t.c.k.mc configure -image [image create pixmap -data $multiUserGroupCalIcon_out]
    } else {
	.t.t.c.k.mc configure -image [image create pixmap -data $multiUserGroupCalIcon_in]
    }
    if { [ lsearch $groupList [string trim $cur_Cal] ] >=0 } { drawCal }
}
lappend ToolBarButtons .t.t.c.k.ii .t.t.c.k.ig .t.t.c.k.oc .t.t.c.k.mc
pack .t.t.c.k.ii .t.t.c.k.ig .t.t.c.k.oc .t.t.c.k.mc  -side left 

$ballon bind .t.t.c.k.ii -balloonmsg "Schaltet aus und ein, ob Termine,\nber die man nur informierte wird,\nangezeigt werden oder nicht"
$ballon bind .t.t.c.k.ig -balloonmsg "Schaltet ein und aus,\nob ignorierte Termine angezeigt werden sollen."
$ballon bind .t.t.c.k.oc -balloonmsg "Schaltet ein und aus,\nob bei Gruppen nur gemeinsame Termin oder\nalle Termine aller Gruppenmitglieder angezeigt werden soll"
$ballon bind .t.t.c.k.mc -balloonmsg "Schalte ein und aus, dass bei Gruppen\ndie Kalender aller Mitglieder\neinzeln dargestellt werden."

pack forget .t.t.c.k
#Buttons im Address-Toolbar
pack forget .t.t.c.a

#Buttons im Projecttoolsbar

button .t.t.c.t.np  -image [image create pixmap -data $newProjIcon] -state disabled -command {
    if { $toolSelection == "T" } {newProj }
}
lappend ToolBarButtons .t.t.c.t.np
pack .t.t.c.t.np -side left -padx 1
$ballon bind .t.t.c.t.np -balloonmsg "Lege einen neues Project an."
pack forget .t.t.c.t






set cur_Cal "User"
label .t.t.lk -text "Kalender: "  -font $bfnt -width 8
set selCalObj .t.t.sel
menubutton $selCalObj -text $cur_Cal -underline -1 -menu .t.t.sel.menu -relief raised -bd 2 -width 22 -font $bfnt -anchor w -indicatoron 1


label .t.t.sr -text " " -width 2

button .t.t.up -image [image create pixmap -data $userPrefsIcon] -state disabled  -command {drawPrefsDialog}
#button .t.t.ttt -text "k" -width 2 -font  $bfnt -command aboutTTT -font -*-symbol-medium-r-normal-*-16-*-*-*-*-*-*-*
button .t.t.ttt -image [image create pixmap -data $minkoIcon24] -state disabled -command aboutMinkowsky
button .t.t.h -image [image create pixmap -data $helpIcon]  -state disabled -command { 
    set docPath "$TclBinPath/../html"
    displayHelp 
}
#button .t.t.gl -text "G" -command showUsersAndGroups

lappend ToolBarButtons .t.t.ttt .t.t.h  .t.t.up
pack .t.t.ttt .t.t.h -side right -fill y
pack .t.t.up -side right -padx 12 -fill y
pack  $selCalObj .t.t.lk -side right -fill y -padx 8


$ballon bind .t.t.up -balloonmsg "Hier kann der Anwender seine\neigenen Voreinstellungen vornehmen."
$ballon bind $selCalObj -balloonmsg "Hier wird ein Kalender ausgewhlt"
$ballon bind .t.t.h -balloonmsg "Hilfe zu $progname (noch nicht programmiert"
#$ballon bind .t.t.gl -balloonmsg "Ausflistung der Gruppeneinteilung\n(Wird spter in dies Hilfsfunktion integriert)"


#Notebook
tixNoteBook .n.nb -ipadx 2 -ipady 2
.n.nb add kalender -label " Kalender " -underline -1 -raisecmd {
     set toolSelection K
    $ballon unbind .t.t.n 
    $ballon unbind .t.t.rl 
    $ballon bind .t.t.n -balloonmsg "Lege einen neuen Termin an."
    $ballon bin .t.t.rl -balloonmsg "Kalender neuladen"
    pack forget .t.t.c.a
    pack forget .t.t.c.t
    pack .t.t.c.k
    
}
.n.nb add todo -label "  Aufgaben und Projekte " -underline -1 -state normal -raisecmd {
     set toolSelection T
    $ballon unbind .t.t.n 
    $ballon unbind .t.t.rl 
    $ballon bind .t.t.n -balloonmsg "Lege ein neues TODO an."
    $ballon bin .t.t.rl -balloonmsg "Projekt und Aufgaben-\nliste neuladen"
    pack forget .t.t.c.k
    pack forget .t.t.c.a
    pack .t.t.c.t
    
    if { [ getProjTodoLists] == 1} {
	refillTODO
    }
}
.n.nb add addressen -label " Addressen " -underline -1 -raisecmd {
     set toolSelection A
    $ballon unbind .t.t.n 
    $ballon unbind .t.t.rl
    $ballon bind .t.t.n -balloonmsg "Lege eine neue Addresse an."
    $ballon bin .t.t.rl -balloonmsg "Addressbuch\nneuladen"
    pack forget .t.t.c.k
    pack forget .t.t.c.t
    pack .t.t.c.a
}
pack .n.nb -side top -fill both -expand 1

set kalWin [ .n.nb subwidget kalender]
set todWin [ .n.nb subwidget todo]
set adrWin [ .n.nb subwidget addressen]

frame $kalWin.c -relief ridge
#frame $kalWin.b 
pack $kalWin.c  -side top -fill both -expand 1

# set xmax 971
# set ymax 756
set rootWidth  [lindex [wm maxsize .] 0]
set rootHeight [lindex [wm maxsize .] 1]

# set rootWidth  1011
# set rootHeight 738



set windWidth  980
set windHeight 865
set scroll ""
set yScrollOn 0
if { $windHeight > $rootHeight} { 
    set scroll "y" 
    set windHeight $rootHeight
    set yScrollOn 1
}

if { $windWidth > $rootWidth} { 
    set scroll "x" 
    set windWidth $rootWidth
} 

set canWidth  [expr $windWidth -8]
set canHeight [expr $windHeight -105 ]
set xmax [expr $windWidth-8]
set ymax 759
if {[ string first $scroll "y"] >=0 } {
#    set xmax [expr $xmax -16]
}
    
if {$scroll == ""} {set scroll "none" }


tixCObjView $kalWin.c.can -width $canWidth -height $canHeight -scrollbar $scroll
$kalWin.c.can subwidget vsb configure -width 12
$kalWin.c.can subwidget hsb configure -width 12

pack $kalWin.c.can
set can [ $kalWin.c.can subwidget canvas]
set canParent $kalWin.c.can


# $ballon bind $can -balloonmsg "Die Kalenderbersicht:
# * Durch klick auf eine freie Flche wird eine neuer Termin angelegt
# * Durch Klick auf einen Termin kann dieser detailiert betrachtet oder 
#   gendert werden
# * Nache einem  Rechtklich auf einen Termin wird man die Kuzrbersicht 
#   eines Termins angezeigt. Hier kann ein Termin auch gelscht werden.
# * Mit den Tasten link und rechts oben in der Kalenderbersicht kann 
#   der Kalender um einen Tage oder eine Woche vor oder zurckgeschoben 
#   werden."

set calDrawn 0
set today [format "%4d%02d%02d" $tyear $tmon $tday]





set cputype $env(CPUTYPE)
getPrinterList
drawWeekGrid 
setTagList 1 [llength $gridTagKOList] [join $gridTagKOList]
drawAddress
drawToDo 


if { [llength $argv] >0 }  {
    set prefUser [lindex $argv 0]
} else {
    set prefUser "-"
}


wm title . $progname


animImages
drawCurrentTime
update
loginDialog $prefUser

