#!/usr/bin/X11/tixwish

proc drawPrefsDialog { } {
    global updo_calPermlist
    global up_displayToolTips ballon
    toplevel .upd
    
    frame .upd.n
    frame .upd.b
    pack .upd.n .upd.b -side top -fill x

    tixNoteBook .upd.n.nb -ipadx 2 -ipady 0 
    .upd.n.nb add calPerms -label  " Rechte im Kalender  " -underline -1
    .upd.n.nb add defPerms -label  " Rechte in Terminen " -underline -1
    .upd.n.nb add pwd -label  " Password " -underline -1
    .upd.n.nb add layout -label  " Layout " -underline -1
    .upd.n.nb add signal -label  " Sonstiges " -underline -1 -state disabled
    pack .upd.n.nb -side top -fill both

    drawUPDcalPerms  [.upd.n.nb subwidget calPerms ]
    drawUPDdatePerms [.upd.n.nb subwidget defPerms ]
    drawUPDlayout    [.upd.n.nb subwidget layout   ]
    drawUPDsignal    [.upd.n.nb subwidget signal   ]
    drawUPDpasswd    [.upd.n.nb subwidget pwd   ]

    button .upd.b.abb -text " Abbruch " -command {closeWin .upd}
    button .upd.b.ok  -text " ndern " -command {
	if { [up_getChanges] == 0} {
	    writeUserPrefs
	    destroy .upd
	    drawNewView
	    if { $up_displayToolTips == 0 } {
#		$ballon -initwait 86400000
		$ballon configure  -state none
	    } else {
#		$ballon -initwait 2000
		$ballon configure  -state balloon
	    }

	}
    }
    pack .upd.b.abb -side left 
    pack .upd.b.ok -side right

    wm title .upd "Benutzer Voreinstellungen"
    centerWin .upd 572 288
    update
    $updo_calPermlist subwidget listbox selection set 0  0
#    update 
#    puts [wm geometry .upd]
}

proc drawUPDcalPerms { win } {
    global fnt bfnt fnt12 bfnt12 pfnt pfnt12
    global groupList
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm up_calPerm
    global updo_calPermlist updo_group updo_check chg_perm
    
    frame $win.l
    frame $win.m 
    frame $win.r
    pack $win.l  $win.m $win.r -side left -fill x -padx 3 -pady 3
    
#Was ist
    label  $win.l.l -text "Gruppen mit Sonderrechten" -font $bfnt12 -anchor nw
    tixScrolledListBox $win.l.g -scrollbar y -height 184 -width 202 -options {listbox.selectMode single} -browsecmd changeSelection
    $win.l.g subwidget vsb configure -width 12
    $win.l.g subwidget hsb configure -width 12
    $win.l.g subwidget listbox configure -font $pfnt12
    pack $win.l.l $win.l.g -fill both -side top -fill x
    set updo_calPermlist $win.l.g

#Rechte von Gruppe Allg bertragen
    array set chg_perm [perm2List $up_calPerm(default)]
    
#rechte
    label  $win.m.l -text "Rechte" -font $bfnt12 -anchor nw
    frame $win.m.r -relief ridge -bd 2
    frame $win.m.b
    frame $win.m.t
    pack $win.m.l  $win.m.r $win.m.b $win.m.t -side top -fill  x


    
    frame $win.m.r.l
    frame $win.m.r.r
    pack $win.m.r.l $win.m.r.r -side left 
    
    label $win.m.r.l.1 -text ""
    label $win.m.r.l.2 -text "Zeiten & Orte" -width 13 -font $bfnt
    label $win.m.r.l.3 -text "berschrift" -width 13 -font $bfnt
    label $win.m.r.l.4 -text "Teilnehmer" -width 13 -font $bfnt
    label $win.m.r.l.5 -text "Kommentar" -width 13 -font $bfnt
    label $win.m.r.l.6 -text "Termin lschen" -width 13 -font $bfnt
    pack $win.m.r.l.1 -side top
    pack $win.m.r.l.2 $win.m.r.l.3 $win.m.r.l.4 $win.m.r.l.5  $win.m.r.l.6 -side top -pady 2

    frame $win.m.r.r.1
    frame $win.m.r.r.2
    frame $win.m.r.r.3
    frame $win.m.r.r.4
    frame $win.m.r.r.5
    frame $win.m.r.r.6
    pack $win.m.r.r.1 $win.m.r.r.2 $win.m.r.r.3 $win.m.r.r.4 $win.m.r.r.5 $win.m.r.r.6 -side top -fill x
    
    label $win.m.r.r.1.l -text "Lesen  " -font $bfnt12 
    label $win.m.r.r.1.s -text " ndern" -font $bfnt12
    label $win.m.r.r.2.ll -text "  "
    label $win.m.r.r.3.ll -text "  "
    label $win.m.r.r.4.ll -text "  "
    label $win.m.r.r.5.ll -text "  "
    label $win.m.r.r.2.lr -text " "
    label $win.m.r.r.3.lr -text " "
    label $win.m.r.r.4.lr -text " "
    label $win.m.r.r.5.lr -text " "
    checkbutton $win.m.r.r.2.l -variable chg_perm(rz)
    checkbutton $win.m.r.r.2.s -variable chg_perm(wz)
    checkbutton $win.m.r.r.3.l -variable chg_perm(r)
    checkbutton $win.m.r.r.3.s -variable chg_perm(w)
    checkbutton $win.m.r.r.4.l -variable chg_perm(rt)
    checkbutton $win.m.r.r.4.s -variable chg_perm(wt)
    checkbutton $win.m.r.r.5.l -variable chg_perm(rk)
    checkbutton $win.m.r.r.5.s -variable chg_perm(wk)
    checkbutton $win.m.r.r.6.d -variable chg_perm(dd)
    pack                 $win.m.r.r.2.ll $win.m.r.r.3.ll $win.m.r.r.4.ll $win.m.r.r.5.ll -side left
    pack                 $win.m.r.r.2.lr $win.m.r.r.3.lr $win.m.r.r.4.lr $win.m.r.r.5.lr -side right
    pack $win.m.r.r.1.l  $win.m.r.r.2.l  $win.m.r.r.3.l  $win.m.r.r.4.l  $win.m.r.r.5.l -side left
    pack $win.m.r.r.1.s  $win.m.r.r.2.s  $win.m.r.r.3.s  $win.m.r.r.4.s  $win.m.r.r.5.s -side right
    pack $win.m.r.r.6.d -side top -fill x
    set updo_check $win.m.r.r

    button $win.m.b.b -text "bernehmen" -command upd_changePerm -font $bfnt12
    pack $win.m.b.b -side top -fill x
    button $win.m.t.out -text "lschen >>>" -command upd_remSelection -font $bfnt12
    button $win.m.t.in  -text "<<< hinzufgen" -command upd_addSelection -font $bfnt12
    pack $win.m.t.out $win.m.t.in -side left -fill x

    #Gruppenauswahl
    label  $win.r.l -text "Gruppen" -font $bfnt12 -anchor nw
    tixScrolledListBox $win.r.g -scrollbar y -height 184 -width 132 -options {listbox.selectMode extended}
    $win.r.g subwidget vsb configure -width 12
    $win.r.g subwidget hsb configure -width 12
    $win.r.g subwidget listbox configure -font $pfnt12
    pack $win.r.l $win.r.g -fill both
    set updo_group $win.r.g
    upd_updateCalPermList
#    update
#    $updo_calPermlist subwidget listbox selection set 0  0
}

proc upd_updateCalPermList { } {
    global updo_calPermlist up_calPerm updo_group groupList
    
    $updo_calPermlist subwidget listbox delete  0 end
    set gpList [lsort [ array names up_calPerm]]
    set idx [lsearch $gpList "default" ]
    set gpList [format "default %s"  [lreplace  $gpList $idx $idx ] ] 
    foreach group $gpList {
	if { $up_calPerm($group) != "off" } {
	    $updo_calPermlist subwidget listbox insert end  [format "%-16s %9s" $group $up_calPerm($group) ]
	}
    }
#    $updo_calPermlist subwidget listbox insert end "1234567890123456789012345678901234567890"

    $updo_group subwidget listbox delete  0 end
    foreach group $groupList {
	if { [lsearch $gpList $group ]<0 } {
	    $updo_group subwidget listbox insert end  $group
	} else {
	    if { $up_calPerm($group) == "off" } {
		$updo_group subwidget listbox insert end  $group
	    }
	}
    }
#    $updo_group subwidget listbox insert end "1234567890123456789012345678901234567890"

}
proc upd_addSelection { } {
    global updo_calPermlist updo_group up_calPerm chg_perm
    
    set selection  [$updo_group subwidget listbox curselection]
    set elemList [$updo_group subwidget listbox get 0 end]
    foreach sel $selection {
	set group [lindex $elemList $sel]
	set up_calPerm($group) [val2perm [List2Val [array get chg_perm]]]
    }
    upd_updateCalPermList
}
proc upd_remSelection { } {
    global updo_calPermlist up_calPerm

    set selection  [$updo_calPermlist subwidget listbox curselection]
    set elemList [$updo_calPermlist subwidget listbox get 0 end]
    foreach sel $selection {
	set group [lindex [lindex $elemList $sel] 0]
	if { $group !="default" } { set up_calPerm($group)  "off" }
    }
    upd_updateCalPermList
}
proc upd_changePerm { } {
    global updo_calPermlist up_calPerm chg_perm

    set selection  [$updo_calPermlist subwidget listbox curselection]
    if { $selection == "" } {
	upd_addSelection
    } else {
	set elemList [$updo_calPermlist subwidget listbox get 0 end]
	foreach sel $selection {
	    set group [lindex [lindex $elemList $sel] 0 ]
	    set up_calPerm($group)  [val2perm [List2Val [array get chg_perm]]]
	}
	upd_updateCalPermList
    }
}
proc changeSelection { } {
    global updo_calPermlist up_calPerm updo_check chg_perm
    
    set selection  [$updo_calPermlist subwidget listbox curselection]
    set elemList [$updo_calPermlist subwidget listbox get 0 end]
    set group [lindex [lindex $elemList $selection] 0]
    array set chg_perm [perm2List $up_calPerm($group)]
}


proc dummy { } { }
proc drawUPDdatePerms {win } {
    global upd_ePerm upd_tPerm upd_aPerm upd_iPerm
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm
    global bfnt fnt bfnt12 fnt12


    array set upd_ePerm [perm2List $up_defEinlPerm]
    array set upd_tPerm [perm2List $up_defTeilnPerm]
    array set upd_aPerm [perm2List $up_defExtPerm]
    array set upd_iPerm [perm2List $up_defInfoPerm]

#    puts [perm2List $up_defEinlPerm]
#    puts [array get upd_ePerm]

    frame $win.t 
    pack $win.t  -side top -fill x -ipady 0 -pady 0


    
    frame $win.t.0
    frame $win.t.1
    frame $win.t.2 
    frame $win.t.3 
    frame $win.t.4 
    frame $win.t.5
    pack $win.t.0 $win.t.1 $win.t.2 $win.t.3 $win.t.4   $win.t.5 -side left -fill x

    label $win.t.0.l -text "  " -width 2
    pack $win.t.0.l

    label $win.t.1.l -text "  "
    frame $win.t.1.c -relief flat -bd 2
    pack $win.t.1.l $win.t.1.c  -side top -padx 1 -pady 2 -fill x
    label $win.t.2.l -text "Einladene" -font $bfnt
    frame $win.t.2.c -relief ridge -bd 2
    pack  $win.t.2.l $win.t.2.c  -side top -padx 1 -pady 2 -fill x
    label $win.t.3.l -text "Teilnehmer" -font $bfnt
    frame $win.t.3.c -relief ridge -bd 2
    pack  $win.t.3.l $win.t.3.c  -side top -padx 1 -pady 2 -fill x
    label $win.t.4.l -text "externe" -font $bfnt
    frame $win.t.4.c -relief ridge -bd 2
    pack  $win.t.4.l $win.t.4.c  -side top -padx 1 -pady 2 -fill x
    label $win.t.5.l -text "Informierte" -font $bfnt
    frame $win.t.5.c -relief ridge -bd 2
    pack  $win.t.5.l $win.t.5.c  -side top -padx 1 -pady 2 -fill x
    
    frame  $win.t.1.c.0
    frame  $win.t.1.c.1
    frame  $win.t.1.c.2
    frame  $win.t.1.c.3
    frame  $win.t.1.c.4
    frame  $win.t.1.c.5
    pack $win.t.1.c.0 $win.t.1.c.1 $win.t.1.c.2 $win.t.1.c.3 $win.t.1.c.4 $win.t.1.c.5 -side top -fill x
    label $win.t.1.c.0.l -text "   "
    label $win.t.1.c.1.l -text "Zeiten & Orte " -font $bfnt -width 15
    label $win.t.1.c.2.l -text "berschrift   " -font $bfnt -width 15
    label $win.t.1.c.3.l -text "Teilnehmer    " -font $bfnt -width 15
    label $win.t.1.c.4.l -text "Kommentare    " -font $bfnt -width 15
    label $win.t.1.c.5.l -text "Termin lschen" -font $bfnt -width 15
    
    pack $win.t.1.c.0.l -side left -fill x -pady 3
    pack $win.t.1.c.1.l $win.t.1.c.2.l $win.t.1.c.3.l $win.t.1.c.4.l $win.t.1.c.5.l -side left -fill x -pady 3




    frame  $win.t.2.c.0
    frame  $win.t.2.c.1
    frame  $win.t.2.c.2
    frame  $win.t.2.c.3
    frame  $win.t.2.c.4
    frame  $win.t.2.c.5
    pack $win.t.2.c.0 $win.t.2.c.1 $win.t.2.c.2 $win.t.2.c.3 $win.t.2.c.4 $win.t.2.c.5 -side top -fill x
    label $win.t.2.c.0.l -text " Lesen  " -font $bfnt12
    label $win.t.2.c.0.s -text " ndern " -font $bfnt12
    label $win.t.2.c.1.ll -text "   "
    label $win.t.2.c.2.ll -text "   "
    label $win.t.2.c.3.ll -text "   "
    label $win.t.2.c.4.ll -text "   "
    label $win.t.2.c.1.lr -text "  "
    label $win.t.2.c.2.lr -text "  "
    label $win.t.2.c.3.lr -text "  "
    label $win.t.2.c.4.lr -text "  "
    checkbutton $win.t.2.c.1.l -variable upd_ePerm(rz)
    checkbutton $win.t.2.c.2.l -variable upd_ePerm(r)
    checkbutton $win.t.2.c.3.l -variable upd_ePerm(rt)
    checkbutton $win.t.2.c.4.l -variable upd_ePerm(rk)
    checkbutton $win.t.2.c.1.s -variable upd_ePerm(wz)
    checkbutton $win.t.2.c.2.s -variable upd_ePerm(w)
    checkbutton $win.t.2.c.3.s -variable upd_ePerm(wt)
    checkbutton $win.t.2.c.4.s -variable upd_ePerm(wk)
    checkbutton $win.t.2.c.5.d -variable upd_ePerm(dd)
    pack  $win.t.2.c.1.ll  $win.t.2.c.2.ll  $win.t.2.c.3.ll  $win.t.2.c.4.ll -side left
    pack  $win.t.2.c.1.lr  $win.t.2.c.2.lr  $win.t.2.c.3.lr  $win.t.2.c.4.lr -side right
    pack $win.t.2.c.0.l $win.t.2.c.1.l $win.t.2.c.2.l $win.t.2.c.3.l $win.t.2.c.4.l -side left -fill x -pady 0
    pack $win.t.2.c.0.s $win.t.2.c.1.s $win.t.2.c.2.s $win.t.2.c.3.s $win.t.2.c.4.s -side right -fill x -pady 0
    pack $win.t.2.c.5.d -side top

    frame  $win.t.3.c.0
    frame  $win.t.3.c.1
    frame  $win.t.3.c.2
    frame  $win.t.3.c.3
    frame  $win.t.3.c.4
    frame  $win.t.3.c.5
    pack $win.t.3.c.0 $win.t.3.c.1 $win.t.3.c.2 $win.t.3.c.3 $win.t.3.c.4 $win.t.3.c.5 -side top -fill x
    label $win.t.3.c.0.l -text " Lesen " -font $bfnt12
    label $win.t.3.c.0.s -text " ndern " -font $bfnt12
    label $win.t.3.c.1.ll -text "  "
    label $win.t.3.c.2.ll -text "  "
    label $win.t.3.c.3.ll -text "  "
    label $win.t.3.c.4.ll -text "  "
    label $win.t.3.c.1.lr -text " "
    label $win.t.3.c.2.lr -text " "
    label $win.t.3.c.3.lr -text " "
    label $win.t.3.c.4.lr -text " "
    checkbutton $win.t.3.c.1.l -variable upd_tPerm(rz)
    checkbutton $win.t.3.c.2.l -variable upd_tPerm(r)
    checkbutton $win.t.3.c.3.l -variable upd_tPerm(rt)
    checkbutton $win.t.3.c.4.l -variable upd_tPerm(rk)
    checkbutton $win.t.3.c.1.s -variable upd_tPerm(wz)
    checkbutton $win.t.3.c.2.s -variable upd_tPerm(w)
    checkbutton $win.t.3.c.3.s -variable upd_tPerm(wt)
    checkbutton $win.t.3.c.4.s -variable upd_tPerm(wk)
    checkbutton $win.t.3.c.5.d -variable upd_tPerm(dd)
    pack  $win.t.3.c.1.ll  $win.t.3.c.2.ll  $win.t.3.c.3.ll  $win.t.3.c.4.ll -side left
    pack  $win.t.3.c.1.lr  $win.t.3.c.2.lr  $win.t.3.c.3.lr  $win.t.3.c.4.lr -side right
    pack $win.t.3.c.0.l $win.t.3.c.1.l $win.t.3.c.2.l $win.t.3.c.3.l $win.t.3.c.4.l -side left -fill x -pady 0
    pack $win.t.3.c.0.s $win.t.3.c.1.s $win.t.3.c.2.s $win.t.3.c.3.s $win.t.3.c.4.s -side right -fill x -pady 0
    pack $win.t.3.c.5.d -side top 

    frame  $win.t.4.c.0
    frame  $win.t.4.c.1
    frame  $win.t.4.c.2
    frame  $win.t.4.c.3
    frame  $win.t.4.c.4
    frame  $win.t.4.c.5
    pack $win.t.4.c.0 $win.t.4.c.1 $win.t.4.c.2 $win.t.4.c.3 $win.t.4.c.4 $win.t.4.c.5 -side top -fill x
    label $win.t.4.c.0.l -text " Lesen " -font $bfnt12
    label $win.t.4.c.0.s -text " ndern " -font $bfnt12
    label $win.t.4.c.1.ll -text "   "
    label $win.t.4.c.2.ll -text "   "
    label $win.t.4.c.3.ll -text "   "
    label $win.t.4.c.4.ll -text "   "
    label $win.t.4.c.1.lr -text "  "
    label $win.t.4.c.2.lr -text "  "
    label $win.t.4.c.3.lr -text "  "
    label $win.t.4.c.4.lr -text "  "
    label $win.t.4.c.5.d  -text "  "
    checkbutton $win.t.4.c.1.l -variable upd_aPerm(rz)
    checkbutton $win.t.4.c.2.l -variable upd_aPerm(r)
    checkbutton $win.t.4.c.3.l -variable upd_aPerm(rt)
    checkbutton $win.t.4.c.4.l -variable upd_aPerm(rk)
    checkbutton $win.t.4.c.1.s -variable upd_aPerm(wz)
    checkbutton $win.t.4.c.2.s -variable upd_aPerm(w)
    checkbutton $win.t.4.c.3.s -variable upd_aPerm(wt)
    checkbutton $win.t.4.c.4.s -variable upd_aPerm(wk)
     set edd_defPerm_AD 0
    pack  $win.t.4.c.1.ll  $win.t.4.c.2.ll  $win.t.4.c.3.ll  $win.t.4.c.4.ll -side left
    pack  $win.t.4.c.1.lr  $win.t.4.c.2.lr  $win.t.4.c.3.lr  $win.t.4.c.4.lr -side right
    pack $win.t.4.c.0.l $win.t.4.c.1.l $win.t.4.c.2.l $win.t.4.c.3.l $win.t.4.c.4.l -side left -fill x -pady 0
    pack $win.t.4.c.0.s $win.t.4.c.1.s $win.t.4.c.2.s $win.t.4.c.3.s $win.t.4.c.4.s -side right -fill x -pady 0
    pack $win.t.4.c.5.d -side top -pady 2

    frame  $win.t.5.c.0
    frame  $win.t.5.c.1
    frame  $win.t.5.c.2
    frame  $win.t.5.c.3
    frame  $win.t.5.c.4
    frame  $win.t.5.c.5
    pack $win.t.5.c.0 $win.t.5.c.1 $win.t.5.c.2 $win.t.5.c.3 $win.t.5.c.4 $win.t.5.c.5 -side top -fill x
    label $win.t.5.c.0.l -text " Lesen " -font $bfnt12 -anchor n
    checkbutton $win.t.5.c.1.l -variable upd_iPerm(rz)
    checkbutton $win.t.5.c.2.l -variable upd_iPerm(r)
    checkbutton $win.t.5.c.3.l -variable upd_iPerm(rt)
    checkbutton $win.t.5.c.4.l -variable upd_iPerm(rk)
    label $win.t.5.c.5.d  -text " "
    pack $win.t.5.c.0.l  -side top -fill x
    pack $win.t.5.c.1.l $win.t.5.c.2.l $win.t.5.c.3.l $win.t.5.c.4.l -side top -fill x -pady 0
    pack $win.t.5.c.5.d -side top -pady 2
}
proc up_getChanges { } {
    global upd_ePerm upd_tPerm upd_aPerm upd_iPerm
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm
    global up_pwd up_pwd2

    if { $up_pwd != $up_pwd2 } {
	ErrorDialog "Die Passwrter stimmen nicht berein"
	return -1
    }

    set up_defEinlPerm   [val2perm [List2Val [array get upd_ePerm]]]
    set up_defTeilnPerm  [val2perm [List2Val [array get upd_tPerm]]]
    set up_defExtPerm    [val2perm [List2Val [array get upd_aPerm]]]
    set up_defInfoPerm   [val2perm [List2Val [array get upd_iPerm]]]
    return 0
}

proc drawUPDlayout {win } {
    global up_beep up_signalCommand updo_signal
    global uCalKernStart uCalKernEnd uGlobalSlotsD uGlobalSlotsW uGlobalSlotsM uGlobalSlotsWG
    global bfnt fnt bfnt12
    global up_displayIgnore up_displayInfo up_displayToolTips showIgnore ignoreInfo

    frame $win.k -relief ridge -bd 2
    frame $win.a -relief ridge -bd 2
    frame $win.z -relief ridge -bd 2
    pack $win.k $win.a $win.z -fill x -pady 1 -padx 1  -ipadx 1
    
    frame $win.a.0
    frame $win.a.1
    frame $win.a.2
    frame $win.a.3
    pack $win.a.0 $win.a.1 $win.a.2 $win.a.3 -side top -fill x -pady 1 -padx 2 -ipadx 2

    label  $win.a.0.l  -text "Anzeigeoptionen" -font $bfnt12
    pack $win.a.0.l  -side left
    checkbutton $win.a.1.c -text "Anzeige von ignorierten Termin" -font $bfnt12 -variable  up_displayIgnore
    checkbutton $win.a.2.c -text "Anzeige von Informations-Termin" -font $bfnt12 -variable  up_displayInfo
    checkbutton $win.a.3.c -text "Anzeige von ToolTips" -font $bfnt12 -variable  up_displayToolTips
    pack  $win.a.1.c  $win.a.2.c  $win.a.3.c  -side left 

    frame  $win.k.0
    frame  $win.k.1
    pack  $win.k.0 $win.k.1  -side top -fill x -pady 1 -padx 2 -ipadx 2

    label  $win.k.0.l  -text "Kernzeit" -width 12 -font $bfnt12
    pack $win.k.0.l  -side left
    tixControl $win.k.1.s -label "von " -min 0 -max $uCalKernEnd -variable uCalKernStart -selectmode immediate -autorepeat true -integer 1  -options { entry.width 2}
    tixControl $win.k.1.e -label " bis " -min $uCalKernStart -max 24 -variable uCalKernEnd -selectmode immediate -autorepeat true -integer 1  -options { entry.width 2}
    pack  $win.k.1.s $win.k.1.e -side left 

    frame  $win.z.3
    frame  $win.z.4
    frame  $win.z.5
    pack $win.z.3 $win.z.4 $win.z.5  -side top -fill x -pady 1 -padx 2 -ipadx 2

    label $win.z.3.l -text "Zahl der \"Zeilen\" fr Termine ohne Uhrzeit"  -font $bfnt12
    pack $win.z.3.l -side left
    
    tixControl $win.z.4.d -label "        im Tageskalender" -min 0 -max 20 -variable uGlobalSlotsD -selectmode immediate -autorepeat true -integer 1  -options { entry.width 2 label.width 22}
    tixControl $win.z.4.w -label "        im Wochenkalender" -min 0 -max 10 -variable uGlobalSlotsW -selectmode immediate -autorepeat true -integer 1  -options { entry.width 2 label.width 22}
    tixControl $win.z.5.m -label "        im Monatskalender" -min 0 -max 10 -variable uGlobalSlotsM -selectmode immediate -autorepeat true -integer 1  -options { entry.width 2 label.width 22}
    tixControl $win.z.5.g -label "        im Gruppenkalender" -min 0 -max 10 -variable uGlobalSlotsWG -selectmode immediate -autorepeat true -integer 1  -options { entry.width 2 label.width 22}
    pack $win.z.4.d $win.z.4.w -side left
    pack $win.z.5.m $win.z.5.g -side left

   
    
}
proc drawUPDsignal {win } {
    global up_beep up_signalCommand updo_signal
    global uCalKernStart uCalKernEnd uGlobalSlotsD uGlobalSlotsW uGlobalSlotsM uGlobalSlotsWG
    global bfnt fnt
    
    frame $win.f -relief ridge -bd 2
#    frame $win.k -relief ridge -bd 2
    pack $win.f  -fill x -pady 1 -padx 2  -ipadx 2
    
    frame  $win.f.1
    frame  $win.f.2
    frame  $win.f.3
    pack  $win.f.1 $win.f.2 $win.f.3 -side top -fill x -pady 1 -padx 2  -ipadx 2

    label $win.f.1.l -text "Erinnerungs-Signal"
    radiobutton $win.f.2.r -variable up_beep -value 1 -text "Beep" -width 10 -command  up_toogleSignalCommand  -anchor nw
    radiobutton $win.f.3.r -variable up_beep -value 0 -text "Kommando" -width 10 -command  up_toogleSignalCommand -anchor nw
    entry $win.f.3.e -textvariable up_signalCommand -width 24 -state disabled
    pack  $win.f.1.l $win.f.2.r $win.f.3.r $win.f.3.e -side left 
    set updo_signal $win.f.3.e

   
    
}
proc up_toogleSignalCommand { } {
    global up_beep updo_signal
    
#    puts "up_toogleSignalCommand"
    if { $up_beep == 1} {
	$updo_signal configure  -state disabled
    } else {
	$updo_signal configure  -state normal
    }
}

proc drawUPDpasswd { win} {
    global up_pwd bfnt up_pwd2 fnt

    frame $win.f -relief ridge -bd 2
    pack $win.f -fill x -pady 2 -padx 2 -ipady 2 -ipadx 2
    frame  $win.f.1
    frame  $win.f.2
   
    pack  $win.f.1 $win.f.2 -side top -fill x -pady 2 -padx 2 -ipady 2 -ipadx 2

    
    label $win.f.1.l -text "Passwort      " -width 15 -font $bfnt
    label $win.f.2.l -text "Wiederholung: " -width 15 -font $bfnt
    entry $win.f.1.e -textvariable up_pwd  -font $fnt -width 16 -show +
    entry $win.f.2.e -textvariable up_pwd2  -font $fnt -width 16 -show +
    pack $win.f.1.l $win.f.2.l $win.f.1.e $win.f.2.e -side left 
}

proc perm2List {perm} {
   
    set chg_perm(rz) 0
    set chg_perm(r) 0
    set chg_perm(rt) 0
    set chg_perm(rk) 0
    set chg_perm(wz) 0
    set chg_perm(w) 0
    set chg_perm(wt) 0
    set chg_perm(wk) 0
    set chg_perm(dd) 0
    set chg_perm(w)  0
    set chg_perm(r)  0
    
    if { [string range $perm 8 8] == "d" } { set chg_perm(dd) 1 }
    if { [string range $perm 7 7] == "k" } { set chg_perm(wk) 1 }
    if { [string range $perm 3 3] == "k" } { set chg_perm(rk) 1 }
    if { [string range $perm 6 6] == "t" } { set chg_perm(wt) 1 }
    if { [string range $perm 2 2] == "t" } { set chg_perm(rt) 1 }
    if { [string range $perm 5 5] == "" } { set chg_perm(w) 1 }
    if { [string range $perm 1 1] == "" } { set chg_perm(r) 1 }
    if { [string range $perm 4 4] == "z" } { set chg_perm(wz) 1 }
    if { [string range $perm 0 0] == "z" } { set chg_perm(rz) 1 }

    if { [expr  $chg_perm(rz)+$chg_perm(r)+$chg_perm(rt)+$chg_perm(rk)] >0 } { set chg_perm(r) 1}
    if { [expr  $chg_perm(wz)+$chg_perm(w)+$chg_perm(wt)+$chg_perm(wk)] >0 } { set chg_perm(w) 1}

#    puts "PERM $perm ->   $chg_perm(rz) $chg_perm(r) $chg_perm(rt) $chg_perm(rk) $chg_perm(wz) $chg_perm(w) $chg_perm(wt) $chg_perm(wk) "
    return [array get chg_perm]
}

proc List2Val {list } {
#    global chg_perm
    array set chg_perm $list
    set rperm [expr $chg_perm(rz) +$chg_perm(r)*2 +$chg_perm(rt)*4 +$chg_perm(rk)*8 ]
    set wperm [expr $chg_perm(wz) +$chg_perm(w)*2 +$chg_perm(wt)*4 +$chg_perm(wk)*8 ]
    set perm [ expr $rperm +$wperm *16 + $chg_perm(dd)*256]
    return $perm
}
proc exportUsersAndGroups { file } {
    global userList groupList groupsByUser usersByGroups
    global pfnt12 fnt12 bfnt12 bfnt
    
    set fid [open $file "w"]

    set ret [request getMemberLists]

    set fList [lindex $ret 0]
#     puts ""
#     puts "-> /$fList/"
    foreach ent $fList {
	set user [lindex $ent 0]
	set list ""
	set glist [lindex $ent 1]
# 	puts "$ent  =>  $user /$glist/"
	foreach grp $glist {
	    set list "$list $grp,"
	}
	set groupsByUser($user) [string trim [string trim [lsort -dictionary $list ] ,] ]
    }
    set fList [lindex $ret 0]
#     puts ""
#     puts "-> /$fList/"
    foreach ent [lindex $ret 1] {
	set grp [lindex $ent 0]
	set list ""
	foreach user [lindex $ent 1] {
	    set list "$list $user,"
	}
	set usersByGroups($grp) [string trim [string trim [lsort -dictionary $list] ,] ]
    }

    puts $fid "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">"
    puts $fid "<html>"
    puts $fid "  <head>"
    puts $fid "    <title>Kapa Dokumentation</title>"
    puts $fid "  </head>\n\n"
    puts $fid "  <body bgcolor=\"\#FFFCF8\">"
    puts $fid "<H1><A NAME=\"users\"></A>Benutzer-Liste</H1>"
    puts $fid "(<A HREF=\"\#groups\">Gruppen-Liste</A> siehe <A HREF=\"\#groups\">unten</A>)"
    puts $fid "<BR><BR>"
    puts $fid "<TABLE BORDER=1>"
    puts $fid "<TR><TD WIDTH=\"120\"><B>Benutzer</B></TD><TD WIDTH=\"640\"><B> ... ist Mitglied in ...</B></TD></TR>"
    foreach user [lsort -dictionary [array names groupsByUser]] {
	puts $fid [format "<TR><TD>%s,</TD><TD>%s</TD></TR>"  $user $groupsByUser($user) ]
    }
    puts $fid "</TABLE>"
    puts $fid "<H1><A NAME=\"groups\"></A>Gruppen-Liste</H1>"
    puts $fid "(<A HREF=\"\#users\">Benutzer-Liste</A> siehe <A HREF=\"\#users\">unten</A>)"
    puts $fid "<BR><BR>"
    puts $fid "<TABLE BORDER=1>"
    puts $fid "<TR><TD WIDTH=\"120\"><B>Gruppe</B></TD><TD WIDTH=\"640\"><B> Gruppen-Mitglieder</B></TD></TR>"
    foreach grp [lsort -dictionary [array names usersByGroups]] {
	puts $fid [format "<TR><TD>%s,</TD><TD>%s</TD></TR>"  $grp $usersByGroups($grp) ]
    }
    puts $fid "</TABLE>"
    puts $fid " <BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>"
    puts $fid " </BODY></HTML>"
    close $fid
}
